/******************************/
/*  Testbench for Code 16.5   */
/******************************/
module tb_shift_reg_pld;

reg		     clk, rst, button_clk, load, mode;
reg  [7:0] data_in;
wire [7:0] pout;

shift_reg_pld U0 (clk, button_clk, rst, load, mode, data_in, pout);

initial begin
     clk = 0;
     mode= 0;
     load= 0;
	   rst = 0;
#5	 rst = 1;
#20	 rst = 0;
end

always #5 clk = ~clk;

initial begin
#20 data_in = 55; #5  load = 1;
                  #10	button_clk = 1;
								  #10	button_clk = 0;
#20 data_in = 34;	#5  load = 0;							  
								  #10	button_clk = 1;
                  #10	button_clk = 0; 
								  #10	button_clk = 1; 
#20 data_in = 31; #10	button_clk = 0;
	                #10	button_clk = 1;
                  #10	button_clk = 0;   
								  #10	button_clk = 1; 
#20 data_in = 77; #10	button_clk = 0;
                  #10	button_clk = 1; 
                  #10	button_clk = 0;
                  #10	button_clk = 1; 
                  #10	button_clk = 0;
#20 mode = 1;     #10	button_clk = 1; 
                  #10	button_clk = 0; 
                  #10	button_clk = 1; 
                  #10	button_clk = 0;
                  #10	button_clk = 1; 
                  #10	button_clk = 0; 
#20 data_in = 90; #10	button_clk = 1; 
                  #10	button_clk = 0;
#20 data_in = 19; #5  load = 1;
                  #10	button_clk = 1;
								  #10	button_clk = 0;
#20 data_in = 29; #5  load = 0;
                  #10	button_clk = 1; 
                  #10	button_clk = 0;
								  #10	button_clk = 1; 
                  #10	button_clk = 0; 
#20 data_in = 60; #10	button_clk = 1; 
                  #10	button_clk = 0;
								  #10	button_clk = 1; 
                  #10	button_clk = 0; 
end

endmodule