/*****************************/
/*       Code 16.1           */
/*****************************/
module shift_reg8b (clk, rst, sin, pout);
  input         clk, rst, sin;
  output [7:0]  pout;
  reg	   [7:0]  q;

  assign pout = q;

  always @(posedge clk or posedge rst) begin
	  if (rst) 
       q <= 8'b0000_0000;
	  else 
       q <= {q[6:0], sin};
  end

endmodule