/*****************************/
/*       Code 16.2           */
/*****************************/
module shift_reg8b_for (clk, rst, sin, pout);
  input         clk, rst, sin;
  output [7:0]  pout;
  reg	   [7:0]  q;
  integer       i;

  assign pout = q;

  always @(posedge clk or posedge rst) begin
	   if (rst) 
        q <= 8'b0000_0000;
	   else begin
	      q[0] <= sin;
        for (i=1; i<8; i=i+1)
           q[i] <= q[i-1];
     end
  end

endmodule