/*****************************/
/*       Code 16.3           */
/*****************************/
module shift_reg8b_slop (clk, rst, sin, pout);
  input         clk, rst, sin;
  output [7:0]  pout;
  reg	   [7:0]  q;

  assign pout = q;

  always @(posedge clk or posedge rst) begin
	   if (rst) 
        q <= 8'b0000_0000;
	   else begin
        q <= q << 1;
        q[0] <= sin;
     end
  end

endmodule