/*****************************/
/*       Code 16.12          */
/*****************************/
module ring_counter2_for (clk, rst, mode, cnt);
   input	      clk, rst, mode;
   output	[7:0]	cnt;
   reg	  [7:0]	cnt;
   integer      i;

always @(posedge clk or posedge rst) begin
	if (rst) cnt <= 1;
	else begin
	  if (mode)
		   if ((cnt == 0) ||(cnt == 128)) 
		      cnt <= 1;
		   else begin
		      cnt[0] <= cnt[7];
		      for (i=1; i<8; i=i+1)
             cnt[i] <= cnt[i-1];
       end
		else  
		   if ((cnt == 0) ||(cnt == 1)) 
		       cnt <= 128;
			 else begin
		      cnt[7] <= cnt[0];
		      for (i=1; i<8; i=i+1)
             cnt[i-1] <= cnt[i];
       end
	end
end

endmodule