/*****************************/
/*       Code 16.11          */
/*****************************/
module ring_counter2_sop (clk, rst, mode, cnt);
   input	      clk, rst, mode;
   output	[7:0]	cnt;
   reg  	[7:0]	cnt;

always @(posedge clk or posedge rst) begin
	if (rst) cnt <= 1;
	else begin
	  if (mode)
		   if ((cnt == 0) ||(cnt == 128)) cnt <= 1;
		   else                           cnt <= cnt << 1;  
		else 
		   if ((cnt == 0) ||(cnt == 1)) cnt <= 128;
			 else                         cnt <= cnt >> 1;
	end
end

endmodule