/***************************************/
/*  Testbench for Code 16.11 ~ 16.13   */
/***************************************/
module tb_ring_counter2;
   reg	    	clk, rst, mode;
   wire	[7:0]	cnt;

//ring_counter2_sop   U0 (.clk(clk), .rst(rst), .mode(mode), .cnt(cnt));
//ring_counter2_conop U0 (.clk(clk), .rst(rst), .mode(mode), .cnt(cnt));
  ring_counter2_for   U0 (.clk(clk), .rst(rst), .mode(mode), .cnt(cnt));

  initial 
    clk = 0;

  always 
    #10 clk = ~clk;

  initial 
    mode = 0;

  always 
    #480 mode = ~mode;

  initial begin
	       rst = 0;
    #5   rst = 1;
    #30	 rst = 0;
    #800 rst = 1;
    #30  rst = 0;
    #300;
  end

endmodule