/******************************/
/*  Testbench for Code 16.15  */
/******************************/
module tb_counter_ud;
  reg		      clk, rst, mode;
  wire	[7:0]	cnt;

  counter_ud U0 (.clk(clk), .rst(rst), .mode(mode), .cnt(cnt));

  initial clk = 0;
  always #10 clk = ~clk;

  initial mode = 0;
  always #320 mode = ~mode;

  initial begin
	       rst = 0;
    #5	 rst = 1;
    #30	 rst = 0;
    #100 rst = 1;
    #30	 rst = 0;
  end

endmodule