/*************************************************/
/*  Code 16.10 : Testbench for Code 16.7 ~ 16.9  */
/*************************************************/
module tb_ring_counter;

  reg        clk, rst;
  wire [7:0] cnt;

   ring_counter U0 (.clk(clk), .rst(rst), .cnt(cnt));
//  ring_counter_for U0 (.clk(clk), .rst(rst), .cnt(cnt));
//  ring_counter_conop U0 (.clk(clk), .rst(rst), .cnt(cnt));

   initial begin
           clk = 0;
	         rst = 1'b0;
      #5   rst = 1'b1;
      #10  rst = 1'b0;
      #100 rst = 1'b1;
      #10  rst = 1'b0;
   end
   
   always 
      #10 clk = ~clk;

endmodule