/******************************/
/*  Testbench for Code 16.20  */
/******************************/
module tb_led_shifter_8modes;

reg		mclk, rst;
reg	[3:0]	mode;
wire	[7:0]	led_data;

led_shifter_8modes U0 (.mclk(mclk), .rst(rst), .mode(mode), .led_data(led_data));

initial mclk = 0;
always #10 mclk = ~mclk;

initial begin
	rst = 1;
#10	rst = 0;
end

initial begin
	mode = 0;
#2000	mode = 1;
#2000	mode = 2;
#2000	mode = 4;
#2000	mode = 8;
#2000	mode = 9;
#2000	mode = 10;
#2000	mode = 12;
end

endmodule