/***************************************/
/*   Testbench for Code 16.23          */
/***************************************/
module tb_detect_0110;

reg		clk, rst, button_clk, din_bit;
wire		detect_out;

detect_0110 U0 (.clk(clk), .rst(rst), .button_clk(button_clk), 
                .din_bit(din_bit), .detect_out(detect_out));

initial clk = 0;
always #5 clk = ~clk;

initial begin
	rst = 0;
#10	rst = 1;
#10	rst = 0;
end

initial begin
#20 din_bit = 0; #10	button_clk = 1;
								 #10	button_clk = 0;   
#20 din_bit = 0; #10	button_clk = 1;
                 #10	button_clk = 0; 
#20 din_bit = 1; #10	button_clk = 1; 
                 #10	button_clk = 0;
	               #10	button_clk = 1;
                 #10	button_clk = 0;   
#20 din_bit = 0; #10	button_clk = 1; 
                 #10	button_clk = 0;
                 #10	button_clk = 1; 
                 #10	button_clk = 0;
#20 din_bit = 1; #10	button_clk = 1; 
                 #10	button_clk = 0;
#20 din_bit = 0; #10	button_clk = 1; 
                 #10	button_clk = 0; 
#20 din_bit = 1; #10	button_clk = 1; 
                 #10	button_clk = 0;
                 #10	button_clk = 1; 
                 #10	button_clk = 0; 
#20 din_bit = 0; #10	button_clk = 1; 
                 #10	button_clk = 0;
#20 din_bit = 1; #10	button_clk = 1; 
                 #10	button_clk = 0;
								 #10	button_clk = 1; 
                 #10	button_clk = 0; 
#20 din_bit = 0; #10	button_clk = 1; 
                 #10	button_clk = 0;
								 #10	button_clk = 1; 
                 #10	button_clk = 0; 
end

endmodule