/*****************************/
/*       Code 16.27          */
/*****************************/
function [7:0] seg_dis;
   input [11:0] key_data;
begin
   case (key_data)  
      12'h001 : seg_dis = 8'b0000_0110; // key_1
      12'h002 : seg_dis = 8'b0101_1011; // key_2
			12'h004 : seg_dis = 8'b0100_1111; // key_3
			12'h008 : seg_dis = 8'b0110_0110; // key_4
			12'h010 : seg_dis = 8'b0110_1101; // key_5
			12'h020 : seg_dis = 8'b0111_1101; // key_6
			12'h040 : seg_dis = 8'b0010_0111; // key_7
			12'h080 : seg_dis = 8'b0111_1111; // key_8
			12'h100 : seg_dis = 8'b0110_1111; // key_9
			12'h200 : seg_dis = 8'b0111_0111; // key_*
			12'h400 : seg_dis = 8'b0011_1111; // key_0
			12'h800 : seg_dis = 8'b0111_1100; // key_#	
			default : seg_dis = 8'b0000_0000;
   endcase
end
endfunction