/*****************************/
/*       Code 16.36          */
/*****************************/
module motor_drive (clk, sensor, motor_data);

input		clk;
input		sensor;

output	[3:0]	motor_data;

reg	[1:0]	m_cnt;
reg	[6:0]	cnt_d;
reg	[4:0]	cnt_s;
reg		clk_div;
reg		mode;
reg	[3:0]	motor_data;

//  ȸӵ ϱ  ŬϽȣ 
always @(posedge clk)
begin
	if (cnt_d == 99) begin
		cnt_d <= 0;
		clk_div <= ~ clk_div;
	end
	else cnt_d <= cnt_d + 1;
	
end

// mode   ȸ  ݴ 
always @(posedge clk_div)
begin
	if (~mode) begin
		case (m_cnt)
			0 : motor_data <= 4'b0011;
			1 : motor_data <= 4'b1001;
			2 : motor_data <= 4'b1100;
			3 : motor_data <= 4'b0110;
			default : motor_data <= 4'b0011;
		endcase
	end
	else begin
		case (m_cnt)
			0 : motor_data <= 4'b0011;
			1 : motor_data <= 4'b0110;
			2 : motor_data <= 4'b1100;
			3 : motor_data <= 4'b1001;
			default : motor_data <= 4'b0011;
		endcase
	end
	m_cnt <= m_cnt + 1;
end

// 񳻿 ִ ڱ    ȸ Ͽ  
always @(posedge sensor)
begin
	if (cnt_s == 19) begin
		mode <= ~mode;
		cnt_s <= 0;
	end
	else	cnt_s <= cnt_s + 1;
end

endmodule
