/*****************************/
/*       Code 16.34          */
/*****************************/
module top_piezo_tone (clk, rst, key_row, key_col, piezo_out);

input		      clk, rst;
input	[3:0]  	key_row;
output[2:0]	  key_col;
output		    piezo_out;
wire	[11:0]	key_data;

keypad_scan U0_keypad (
      .clk(clk),
      .rst(rst), 
      .key_col(key_col), 
      .key_row(key_row), 
      .key_data(key_data)
      );

piezo_tone U0_piezo_tone (
			.clk	  (clk),
			.rst	  (rst),
			.key_in	(key_data[7:0]),
			.piezo_freq (piezo_out)
			);

endmodule			