/*****************************/
/*       Code 16.7           */
/*****************************/
module ring_counter (clk, rst, cnt);
  input		     clk, rst;
  output [7:0] cnt;
  reg	   [7:0] cnt;

  always @(posedge clk or posedge rst) begin
	  if (rst) cnt <= 1;
	  else begin
		   if ((cnt == 0) ||(cnt == 128)) cnt <= 1;
		   else cnt <= cnt << 1;
	  end
  end

endmodule