/*****************************/
/*       Code 16.9           */
/*****************************/
module ring_counter_conop (clk, rst, cnt);
  input		     clk, rst;
  output [7:0] cnt;
  reg	   [7:0] cnt;

  always @(posedge clk or posedge rst) begin
	  if (rst) cnt <= 1;
	  else begin
		   if ((cnt == 0) ||(cnt == 128)) cnt <= 1;
		   else cnt <= {cnt[6:0], cnt[7]};
	  end
  end

endmodule