/*****************************/
/*       Code 16.8           */
/*****************************/
module ring_counter_for (clk, rst, cnt);
  input		     clk, rst;
  output [7:0] cnt;
  reg	   [7:0] cnt;
  integer      i;

  always @(posedge clk or posedge rst) begin
	  if (rst) cnt <= 1;
	  else begin
		   if ((cnt == 0) ||(cnt == 128)) 
		      cnt <= 1;
		   else begin
		      cnt[0] <= cnt[7];
		      for (i=1; i<8; i=i+1)
             cnt[i] <= cnt[i-1];
       end
	  end
  end

endmodule