/*******************************************/
/*  Code 16.22 : Testbench for Code 16.21  */
/*******************************************/
module tb_seq_det_moore;

reg		clk, rst, button_clk, din_bit;
wire		dout_bit;

seq_det_moore U0 (.clk(clk), .rst(rst), .button_clk(button_clk), .din_bit(din_bit), .dout_bit(dout_bit));

initial clk = 0;
always #5 clk = ~clk;


initial begin
#30	rst = 0;      button_clk = 0;
#30	rst = 1;
#30	rst = 0;
end

always begin
#30	button_clk = 1; 
#10  din_bit = 1;
#30	button_clk = 0;
#30	button_clk = 1; 
#30	button_clk = 0; 
#30	button_clk = 1; 
#30	button_clk = 0;
#30	button_clk = 1; 
#10  din_bit = 0;
#30	button_clk = 0; 
#30	button_clk = 1; 
#30	button_clk = 0;
#30	button_clk = 1; 
#30	button_clk = 0; 
#30	button_clk = 1; 
#10  din_bit = 1;
#30	button_clk = 0;
#30	button_clk = 1; 
#10  din_bit = 0;
#30	button_clk = 0; 
#30	button_clk = 1; 
#10  din_bit = 1;
#30	button_clk = 0;
#30	button_clk = 1;
#30	button_clk = 0; 
end

endmodule