/*****************************/
/*       Code 16.26          */
/*****************************/
module keypad_7segdis (clk, rst, key_col, key_row, seg_com, seg_data);

  input		      clk, rst;
  input	 [3:0]	key_row;
  output [2:0]	key_col;
  output [7:0]	seg_com, seg_data;
  wire   [11:0] key_data;

  keypad_scan U0 (clk, rst, key_col, key_row, key_data);
  
  assign seg_data = seg_dis(key_data);
  assign seg_com = 8'b0111_1111;
  
endmodule