/*******************************************/
/*  Code 16.25 : Testbench for Code 16.24  */
/*******************************************/
module tb_keypad_scan;

  reg		    clk, rst;
  reg	[3:0]	key_row;
  wire[2:0]	key_col;
  wire[11:0]key_data;

keypad_scan U0 (
                .clk(clk), 
                .rst(rst), 
                .key_col(key_col), 
                .key_row(key_row), 
                .key_data(key_data) );

initial
   clk = 0;

always 
   #10 clk = ~clk;

initial begin
  	    rst = 0;
    #10	rst = 1;
    #10	rst = 0;
    #10;
  repeat (3) begin
	      key_row = 4'b0000;
    #20	key_row = 4'b0001;
    #20;
  end
  repeat (3) begin
	      key_row = 4'b0000;
    #20	key_row = 4'b0010;
    #20;
  end
  repeat (3) begin
	      key_row = 4'b0000;
    #20	key_row = 4'b0100;
    #20;
  end
  repeat (3) begin
	      key_row = 4'b0000;
    #20	key_row = 4'b1000;
    #20;
  end
end

endmodule